//Tutorial 2: Introduction to C++

#include <iostream>
#include <vector>

//using namespace std;	//Uncomment to remove "std::" in front of functions

struct Vec2f {
	//public members by default
	Vec2f() = default;
	Vec2f(float x, float y) : x(x), y(y) {}
	
	float x = 0.f;	
	float y = 0.f;
};

Vec2f add(Vec2f a, Vec2f b) { return Vec2f(a.x + b.x, a.y + b.y); }
Vec2f operator+(Vec2f a, Vec2f b) { return Vec2f(a.x + b.x, a.y + b.y); }

std::ostream &operator<<(std::ostream &out, Vec2f const &a) {
	return out << a.x << ' ' << a.y;
}

class Triangle {
	//Private members by default
	Vec2f m_verts[3];	

public:
	Triangle() = default;
	Triangle(Vec2f a, Vec2f b, Vec2f c) {
		m_verts[0] = a;
		m_verts[1] = b;
		m_verts[2] = c;
	}

	//functions to get/read value
	Vec2f a() const { return m_verts[0]; }
	Vec2f b() const { return m_verts[1]; }
	Vec2f c() const { return m_verts[2]; }

	Vec2f operator[](int index) const { return m_verts[index]; }

	//functions to set value
	Vec2f &a() { return m_verts[0]; }
	Vec2f &b() { return m_verts[1]; }
	Vec2f &c() { return m_verts[2]; }

	Vec2f &operator[](int index) { return m_verts[index]; }	
};



int main()
{
	std::cout << "Hello, World!\n" << std::endl;
	//Sample Vertices 
	Vec2f v0(1, 2);
	Vec2f v1(3, 4);
	Vec2f v2(5, 6);

	//Vertices in a dynamic array
	std::vector<Vec2f> verts;
	verts.push_back(v0);
	verts.push_back(v1);
	verts.push_back(v2);
	
	//Vertices in class "Triangle"
	Triangle tri(v0, v1, v2);
	
	for (int i = 0; i < 3; i++) {
		std::cout << "verts[" << i << "]:" << verts[i] << std::endl;
		std::cout << "tri[" << i << "]:" << tri[i] << std::endl;
	}

	std::cout << "\nv0 + v1: " << v0 + v1 << std::endl;

    return 0;
}